/*
 *  linux/boot/head.s
 *
 *  (C) 1991  Linus Torvalds
 */

/*
 *  head.s contains the 32-bit startup code.
 *
 * NOTE!!! Startup happens at absolute address 0x00000000, which is also where
 * the page directory will exist. The startup code will be overwritten by
 * the page directory.
 */
/*
 * head.s 32 λ롣
 * ע!!! 32 λǴӾԵַ0x00000000 ʼģҲͬҳĿ¼
 * ĵط뽫ҳĿ¼ǵ
 */
.text
.globl _idt,_gdt,_pg_dir,_tmp_floppy_area
_pg_dir:		# ҳĿ¼
.globl startup_11

startup_11:   				# GNU ˵ÿֱҪ'$'ʼǱʾַ
	movl $0x10,%eax			#  ٴע!!! Ѿ32 λģʽ$0x10 ǰѵַ0x10 װ	
   							#  μĴʵȫֶеƫֵ߸ȷ˵һ
    						#  ѡйѡ˵μsetup.s е˵$0x10 ĺ
    						#  Ȩ0(λ0-1=0)ѡȫ(λ2=0)ѡе2 (λ3-15=2)
    						#  ǣds,es,fs,gs еѡΪsetup.s йݶΣȫֶĵ2 
    						#  =0x10ջstack_start ָ user_stack ڣȻʹµж
    						#  ȫֶ.µȫֶгʼsetup.s еĻһ޳
    						#   8MB ޸Ϊ 16MB
	mov %ax,%ds
	mov %ax,%es
	mov %ax,%fs
	mov %ax,%gs
	lss _stack_start,%esp		# ʾ_stack_start->ss:espϵͳջstack_start kernel/sched.c
	call _setup_idt				# жӳ
	call _setup_gdt				# ȫӳ
	movl $0x10,%eax		# reload all the segment registers
	mov %ax,%ds			# after changing gdt. CS was already
	mov %ax,%es			# reloaded in 'setup_gdt'
	mov %ax,%fs			# Ϊ޸gdtҪװеĶμĴ
	mov %ax,%gs			# CS μĴѾsetup_gdt ¼عˡ
	lss _stack_start,%esp
	
	# ڲA20 ַǷѾõķڴַ0x000000 д
	# һֵȻڴַ0x100000(1M)ǷҲֵһֱͬĻһֱ
	# ȽȥҲѭʾַA20 ûѡͨں˾Ͳʹ1M ڴ档
	xorl %eax,%eax
1:	incl %eax			# check that A20 really IS enabled
	movl %eax,0x000000	# loop forever if it isn't
	cmpl %eax,0x100000
	je 1b				# '1b'ʾ(backward)ת1 ȥ
						# '5f'ʾǰ(forward)ת5 ȥ	

/*
 * NOTE! 486 should set bit 16, to check for write-protect in supervisor
 * mode. Then it would be unnecessary with the "verify_area()"-calls.
 * 486 users probably want to set the NE (#5) bit also, so as to use
 * int 16 for math errors.
 */
/*
 * ע! γУ486 Ӧýλ16 λԼڳûģʽµд,
 * ˺"verify_area()"оͲҪˡ486 ûͨҲ뽫NE(#5)λԱ
 * ѧЭĳʹint 16
 */
 # γ43-65ڼѧЭоƬǷڡ޸ĿƼĴCR0
 # ЭִһЭָĻ˵ЭоƬڣ
 # ҪCR0 еЭλEMλ2λЭڱ־MPλ1
	movl %cr0,%eax			# check math chip
	andl $0x80000011,%eax	# Save PG,PE,ET
	/* "orl $0x10020,%eax" here for 486 might be good */
	orl $2,%eax				# set MP
	movl %eax,%cr0
	call check_x87
	jmp after_page_tables

 /*
  * We depend on ET to be correct. This checks for 287/387.
  */
 /*
  * ET ־ȷ287/387 
  */
check_x87:
	fninit
	fstsw %ax
	cmpb $0,%al
	je 1f				/* no coprocessor: have to set bits */
	movl %cr0,%eax		 # ڵǰת1 дcr0
	xorl $6,%eax		/* reset MP, set EM */
	movl %eax,%cr0
	ret
.align 2				 # ".align 2"ĺָ洢߽"2"ʾַ2 λΪ㣬
						 # 4 ֽڷʽڴַ
1:	.byte 0xDB,0xE4		/* fsetpm for 287, ignored by 387 */
	ret

/*
 *  setup_idt
 *
 *  sets up a idt with 256 entries pointing to
 *  ignore_int, interrupt gates. It then loads
 *  idt. Everything that wants to install itself
 *  in the idt-table may do so themselves. Interrupts
 *  are enabled elsewhere, when we can be relatively
 *  sure everything is ok. This routine will be over-
 *  written by the page tables.
 */
/*
 * жӳ setup_idt
 *
 * жidt óɾ256 ָignore_int жšȻж
 * Ĵ(lidt ָ)ʵõжԺٰװطΪһ
 * ʱٿжϡӳ򽫻ᱻҳǵ
 */
  # жеȻҲ8 ֽɣʽȫֱеĲͬΪ
  # (Gate Descriptor)0-1,6-7 ֽƫ2-3 ֽѡ4-5 ֽһЩ־
_setup_idt:
	lea ignore_int,%edx		 # ignore_int Чַƫֵֵ->edx Ĵ
	movl $0x00080000,%eax	 # ѡ0x0008 eax ĸ16 λС
	movw %dx,%ax			/* selector = 0x0008 = cs */
							 # ƫֵĵ16 λeax ĵ16 λСʱeax 
							 #4 ֽڵֵ
	movw $0x8E00,%dx		/* interrupt gate - dpl=0, present */

	lea _idt,%edi			 # _idt жĵַ
	mov $256,%ecx
rp_sidt:
	movl %eax,(%edi)		 # жС
	movl %edx,4(%edi)
	addl $8,%edi			 # edi ָһ
	dec %ecx
	jne rp_sidt
	lidt idt_descr			 # жĴֵ
	ret

/*
 *  setup_gdt
 *
 *  This routines sets up a new gdt and loads it.
 *  Only two entries are currently built, the same
 *  ones that were built in init.s. The routine
 *  is VERY complicated at two whole lines, so this
 *  rather long comment is certainly needed :-).
 *  This routine will beoverwritten by the page tables.
 */
/*
 * ȫ setup_gdt
 * ӳһµȫgdtءʱǰ
 * һӳֻУǳġӣԵȻҪôעˡ
 */
_setup_gdt:
	lgdt gdt_descr			# ȫĴ(ú)
	ret

	/*
	 * I put the kernel page tables right after the page directory,
	 * using 4 of them to span 16 Mb of physical memory. People with
	 * more than 16MB will have to expand this.
	 */
	/* Linus ں˵ڴҳֱӷҳĿ¼֮ʹ4 Ѱַ16 Mb ڴ档
	 * ж16 Mb ڴ棬Ҫ޸ġ
	 */
 	 # ÿҳΪ4 Kb ֽڣÿҳҪ4 ֽڣһҳԴ1000 
 	 # һѰַ4 Kb ĵַռ䣬һҳͿѰַ4 Mb ڴ档
	 # ҳĸʽΪǰ0-11 λһЩ־Ƿڴ(P λ0)д(R/W λ1)
 	 # ͨûǳûʹ(U/S λ2)Ƿ޸Ĺ(Ƿ)(D λ6)ȣλ12-31 
 	 # ҳַָһҳڴʼַ
 
.org 0x1000		# ƫ0x1000 ʼǵ1 ҳƫ0 ʼҳĿ¼
pg0:

.org 0x2000
pg1:

.org 0x3000
pg2:

.org 0x4000
pg3:

.org 0x5000		# ڴݿƫ0x5000 ʼ
/*
 * tmp_floppy_area is used by the floppy-driver when DMA cannot
 * reach to a buffer-block. It needs to be aligned, so that it isn't
 * on a 64kB border.
 */
/* DMAֱӴ洢ʣܷʻʱtmp_floppy_area ڴ
 * ͿɹʹáַҪͲԽ64kB ߽硣
 */
_tmp_floppy_area:
	.fill 1024,1,0		# 1024 ÿ1 ֽڣֵ0

# ⼸ջ(pushl)Ϊ/init/main.c ͷ׼
# ǰ3 ջָ֪ʲôõģҲLinus ڵʱܿõġ
after_page_tables:
	pushl $0			# These are the parameters to main :-)
	pushl $0
	pushl $0
	pushl $L6			# return address for main, if it decides to.
	pushl $_start
	jmp setup_paging
L6:
	jmp L6				# main should never return here, but
						# just in case, we know what happens.

/* This is the default interrupt "handler" :-) */
/* Ĭϵжϡ*/
int_msg:
	.asciz "Unknown interrupt\n\r"		# ַδ֪ж(س)
.align 2
ignore_int:
	pushl %eax
	pushl %ecx
	pushl %edx
	
	# ע⣡ds,es,fs,gs Ȼ16 λļĴջ
	# Ȼ32 λʽջҲҪռ4 ֽڵĶջռ䡣
	push %ds
	push %es
	push %fs
	movl $0x10,%eax		# öѡʹds,es,fs ָgdt еݶΣ
	mov %ax,%ds
	mov %ax,%es
	mov %ax,%fs
	pushl $int_msg		# ѵprintk Ĳָ루ַջ
						# ע⣡int_msgǰӡ$ʾint_msgŴĳ'Unkn'ջ
	call _printk		# '_printk'printk ģеڲʾ
	popl %eax
	pop %fs
	pop %es
	pop %ds
	popl %edx
	popl %ecx
	popl %eax
	iret				# жϷأжϵʱѹջCPU ־Ĵ32 λֵҲ


/*
 * Setup_paging
 *
 * This routine sets up paging by setting the page bit
 * in cr0. The page tables are set up, identity-mapping
 * the first 16MB. The pager assumes that no illegal
 * addresses are produced (ie >4Mb on a 4Mb machine).
 *
 * NOTE! Although all physical memory should be identity
 * mapped by this routine, only the kernel page functions
 * use the >1Mb addresses directly. All "normal" functions
 * use just the lower 1Mb, or the local data space, which
 * will be mapped to some other place - mm keeps track of
 * that.
 *
 * For those with more memory than 16 Mb - tough luck. I've
 * not got it, why should you :-) The source is here. Change
 * it. (Seriously - it shouldn't be too difficult. Mostly
 * change some constants etc. I left it at 16Mb, as my machine
 * even cannot be extended past that (ok, but it was cheap :-)
 * I've tried to show which constants to change by having
 * some kind of marker at them (search for "16Mb"), but I
 * won't guarantee that's all :-( )
 */
/*
 * ӳͨÿƼĴcr0 ı־PG λ31ڴķҳܣ
 * øҳݣԺӳǰ16 MB ڴ档ҳٶǷ
 * ַӳ䣨Ҳֻ4Mb Ļó4Mb ڴַ
 *
 * ע⣡еַӦӳкӳ䣬ֻںҳ
 * ֱʹ>1Mb ĵַСһ㡱ʹõ1Mb ĵַռ䣬ʹþֲ
 * ռ䣬ַռ佫ӳ䵽һЩطȥ -- mm(ڴ)Щµġ
 *
 * Щж16Mb ڴļһ - ̫ˣһûУΪʲô?
 * ޸İɡʵϣⲢ̫ѵġֻͨ޸һЩȡҰΪ
 * 16MbΪҵĻôܳޣȻҵĻܱ˵?
 * Ѿͨĳ־ҪĶĵط16MbҲܱ֤Щ
 * Ķˣ
 */
.align 2
setup_paging:					 # ȶ5 ҳڴ棨1 ҳĿ¼ + 4 ҳҳ
	movl $1024*5,%ecx			/* 5 pages - pg_dir+4 page tables */
	xorl %eax,%eax	
	xorl %edi,%edi				/* pg_dir is at 0x000 */
								 # ҳĿ¼0x000 ַʼ
	cld;rep;stosl
	# 4 ҳĿ¼еǹ4 ҳֻ4 
	# ҳĿ¼ĽṹҳĽṹһ4 ֽΪ1 μ˵
	# "$pg0+7"ʾ0x00001007ҳĿ¼еĵ1 
	# 1 ҳڵĵַ = 0x00001007 & 0xfffff000 = 0x1000
	# 1 ҳԱ־ = 0x00001007 & 0x00000fff = 0x07ʾҳڡûɶд
	movl $pg0+7,_pg_dir			/* set present bit/user r/w */
	movl $pg1+7,_pg_dir+4		/*  --------- " " --------- */
	movl $pg2+7,_pg_dir+8		/*  --------- " " --------- */
	movl $pg3+7,_pg_dir+12		/*  --------- " " --------- */
	
	# 6 д4 ҳݣУ4(ҳ)*1024(/ҳ)=4096 (0 - 0xfff)
	# Ҳӳڴ 4096*4Kb = 16Mb
	# ÿǣǰӳڴַ + ҳı־Ϊ7
	# ʹõķǴһҳһʼ˳дһҳһҳе
	# λ1023*4 = 4092һҳһλþ$pg3+4092
	movl $pg3+4092,%edi			 # edi->һҳһ
	movl $0xfff007,%eax			/*  16Mb - 4096 + 7 (r/w user,p) */
								 # 1 Ӧڴҳĵַ0xfff000
								 # Ա־7Ϊ0xfff007.
	std							 # λλedi ֵݼ(4 ֽ)
1:	stosl						/* fill pages backwards - more efficient :-) */
	subl $0x1000,%eax			 # ÿдһֵַ0x1000
	jge 1b						 # С0 ˵ȫдˡ
	# ҳĿ¼ַĴcr3 ֵָҳĿ¼
	xorl %eax,%eax			/* pg_dir is at 0x0000 */  # ҳĿ¼0x0000 
	movl %eax,%cr3			/* cr3 - page directory start */
	# ʹ÷ҳcr0 PG ־λ31
	movl %cr0,%eax
	orl $0x80000000,%eax	 # PG ־
	movl %eax,%cr0			/* set paging (PG) bit */
	ret			/* this also flushes prefetch-queue */	
# ڸıҳ־ҪʹתָˢԤȡָУõǷָret
# ÷ָһǽջеmain ĵַʼ/init/main.c 
# 򵽴ˡ

.align 2		# 4 ֽڷʽڴַ߽硣
.word 0			# ճ2ֽڣĳ4ֽڶġ

#lidt ָ6 ֽڲȣַ
idt_descr:
	.word 256*8-1			# idt contains 256 entries
	.long _idt
.align 2
.word 0

# lgdt ָ6 ֽڲȣַ
gdt_descr:
	.word 256*8-1			# so does gdt (not that that's any
	.long _gdt				# magic number, but it works for me :^)

	.align 8
_idt:	.fill 256,8,0		# idt is uninitialized  # 256 ÿ8 ֽڣ0

# ȫֱǰ4 ֱǿãݶϵͳ
# ϵͳlinux ûô滹Ԥ252 Ŀռ䣬ڷ
# ֲ(LDT)ͶӦ״̬TSS 
# (0-nul, 1-cs, 2-ds, 3-sys, 4-TSS0, 5-LDT0, 6-TSS1, 7-LDT1, 8-TSS2 etc...)
_gdt:	.quad 0x0000000000000000		/* NULL descriptor */
		.quad 0x00c09a0000000fff		/* 16Mb */ # 󳤶16M
		.quad 0x00c0920000000fff		/* 16Mb */ # ݶ󳤶16M
		.quad 0x0000000000000000		/* TEMPORARY - don't use */
		.fill 252,8,0					/* space for LDT's and TSS's etc */ # Ԥռ
