/*
 * This file contains some defines for the floppy disk controller.
 * Various sources. Mostly "IBM Microcomputers: A Programmers
 * Handbook", Sanches and Canton.
 */
/*
 * ļкһЩ̿һЩ塣ЩϢжദԴȡ
 * Sanches  CantonġIBM΢ͼԱֲᡱһ顣
 */
#ifndef _FDREG_H
#define _FDREG_H

// һЩͺԭ˵
extern int ticks_to_floppy_on(unsigned int nr);
extern void floppy_on(unsigned int nr);
extern void floppy_off(unsigned int nr);
extern void floppy_select(unsigned int nr);
extern void floppy_deselect(unsigned int nr);

// й̿һЩ˿ںͷŵĶ塣
/* Fd controller regs. S&C, about page 340 */
/* ̿FDCĴ˿ڡժS&CԼ340ҳ*/
#define FD_STATUS	0x3f4		// ״̬Ĵ˿ڡ
#define FD_DATA		0x3f5		// ݶ˿
#define FD_DOR		0x3f2		/* Digital Output Register */
								// ĴҲΪֿƼĴ
#define FD_DIR		0x3f7		/* Digital Input Register (read) */
								// Ĵ
#define FD_DCR		0x3f7		/* Diskette Control Register (write)*/
								// ִʿƼĴ

/* Bits of main status register */
/* ״̬Ĵλĺ*/
#define STATUS_BUSYMASK	0x0F	/* drive busy mask */
								// æλÿλӦһ
#define STATUS_BUSY	0x10		/* FDC busy */
								// ̿æ
#define STATUS_DMA	0x20		/* 0- DMA mode */
								// 0 - ΪDMAݴģʽ 1- ΪDMAģʽ
#define STATUS_DIR	0x40		/* 0- cpu->fdc */
								// ䷽0-CPU-> fdc, 1 - ෴.
#define STATUS_READY	0x80	/* Data reg ready */
								// ݼĴλ

/* Bits of FD_ST0 */			// ״ֽ̬0 ST0λĺ塣
#define ST0_DS		0x03		/* drive select mask */
								// ѡţжʱţ
#define ST0_HA		0x04		/* Head (Address) */
								// ͷ
#define ST0_NR		0x08		/* Not Ready */
								// Ϊ׼á
#define ST0_ECE		0x10		/* Equipment chech error */
								// 豸(ŵУ׼)
#define ST0_SE		0x20		/* Seek end */
								// ѰУִн
#define ST0_INTR	0xC0		/* Interrupt code mask */
								// жϴλжԭ򣩣00 - 
								// 01 - 쳣; 10 - Ч 11 - fdd״̬ı

/* Bits of FD_ST1 */			// ״ֽ̬1ST1λĺ		
#define ST1_MAM		0x01		/* Missing Address Mark */
								// δҵַ־ID AM).
#define ST1_WP		0x02		/* Write Protect */
								// д
#define ST1_ND		0x04		/* No Data - unreadable */
								// δҵָ.
#define ST1_OR		0x10		/* OverRun */
								// ݴ䳬ʱ(DMAϣ
#define ST1_CRC		0x20		/* CRC error in data or addr */
								// CRC 
#define ST1_EOC		0x80		/* End Of Cylinder */
								// ʳһŵϵš

/* Bits of FD_ST2 */			// ״ֽ̬2ST2λĺ
#define ST2_MAM		0x01		/* Missing Addess Mark (again) */
								// δҵݵַ־
#define ST2_BC		0x02		/* Bad Cylinder */
								// ŵ
#define ST2_SNS		0x04		/* Scan Not Satisfied */
								// (ɨ)
#define ST2_SEH		0x08		/* Scan Equal Hit */
								// 
#define ST2_WC		0x10		/* Wrong Cylinder */
								// ŵţŲ
#define ST2_CRC		0x20		/* CRC error in data field */
								// CRC 
#define ST2_CM		0x40		/* Control Mark = deleted */
								// ʳһŵϵš

/* Bits of FD_ST3 */			// ״ֽ̬3ST3λĺ塣
#define ST3_HA		0x04		/* Head (Address) */
								// ͷš
#define ST3_TZ		0x10		/* Track Zero signal (1=track 0) */
								// ŵźš
#define ST3_WP		0x40		/* Write Protect */
								// д

/* Values for FD_COMMAND */		// 
#define FD_RECALIBRATE	0x07	/* move to track 0 */
								// Уͷ˵ŵ
#define FD_SEEK		0x0F		/* seek track */
								// ͷѰ
#define FD_READ		0xE6		/* read with MT, MFM, SKip deleted */
								// ݣMTŵMFMʽɾݣ
#define FD_WRITE	0xC5		/* write with MT, MFM */
								// дݣMTMFM
#define FD_SENSEI	0x08		/* Sense Interrupt Status */
								// ж״̬
#define FD_SPECIFY	0x03		/* specify HUT etc */
								// 趨ʡͷжʱȣ

/* DMA commands */				//DMA 
#define DMA_READ	0x46		// DMA ̣DMAʽ֣DMA˿ 12,11
#define DMA_WRITE	0x4A		// DMA д̣DMAʽ֡

#endif
