#ifndef _SCHED_H
#define _SCHED_H

#define NR_TASKS 64					// ϵͳͬʱ񣨽̣
#define HZ 100						// ϵͳʱӵδƵ(1 ٺȣÿδ10ms)

#define FIRST_TASK task[0]			// 0 Ƚ⣬һš
#define LAST_TASK task[NR_TASKS-1]	// еһ

#include <linux/head.h>				// head ͷļ˶ļ򵥽ṹͼѡ
#include <linux/fs.h>				// ļϵͳͷļļṹfile,buffer_head,m_inode ȣ
#include <linux/mm.h>				// ڴͷļҳСһЩҳͷźԭ͡
#include <signal.h>					// źͷļźŷųźŽṹԼźŲԭ͡

#if (NR_OPEN > 32)
#error "Currently the close-on-exec-flags are in one word, max 32 files/proc"
#endif

// ﶨ˽пܴ״̬
#define TASK_RUNNING 		0		// л׼
#define TASK_INTERRUPTIBLE 	1		// ̴ڿжϵȴ״̬
#define TASK_UNINTERRUPTIBLE 2		// ̴ڲжϵȴ״̬ҪI/O ȴ
#define TASK_ZOMBIE 		3		// ̴ڽ״̬ѾֹͣУ̻ûźš
#define TASK_STOPPED 		4		// ֹͣ

#ifndef NULL
#define NULL ((void *) 0)			// NULL Ϊָ롣
#endif

// ƽ̵ҳĿ¼ҳLinus Ϊںӵĺ֮һ( mm/memory.c)
extern int copy_page_tables (unsigned long from, unsigned long to, long size);
// ͷҳָڴ鼰ҳ( mm/memory.c)
extern int free_page_tables (unsigned long from, unsigned long size);

// ȳĳʼ( kernel/sched.c)
extern void sched_init(void);
// ̵Ⱥ( kernel/sched.c)
extern void schedule(void);
// 쳣()жϴʼжϵŲжźš( kernel/traps.c)
extern void trap_init(void);
#ifndef PANIC
// ʾں˳ϢȻѭ( kernel/panic.c)
volatile void panic(const char * str);
#endif
// tty дָȵַ( kernel/chr_drv/tty_io.c)
extern int tty_write(unsigned minor,char * buf,int count);

extern void record_task_state(long pid, long new_state, long jiffies, const char* fun_name, int line_num);
#define RECORD_TASK_STATE(pid, state, jiffies) record_task_state(pid, state, jiffies, __FUNCTION__, __LINE__);

// Ϊ뾭Ľ״̬ƥ䣬⣬ﶨһµĽ״̬
#define TS_CREATE 	0	// 
#define TS_READY	1	// ̬
#define TS_RUNNING	2	// ̬
#define TS_WAIT		3	// ̬
#define TS_STOPPED	4	// 

typedef int (*fn_ptr)();		// 庯ָ͡

// ѧЭʹõĽṹҪڱлʱ i387 ִ״̬Ϣ
struct i387_struct {
	long	cwd;				// (Control word)
	long	swd;				// ״̬(Status word)
	long	twd;				// (Tag word)
	long	fip;				// Эָ롣
	long	fcs;				// ЭμĴ
	long	foo;
	long	fos;
	long	st_space[20];	/* 8*10 bytes for each FP-reg = 80 bytes */
};

// ״̬ݽṹ
struct tss_struct {
	long	back_link;	/* 16 high bits zero */
	long	esp0;
	long	ss0;		/* 16 high bits zero */
	long	esp1;
	long	ss1;		/* 16 high bits zero */
	long	esp2;
	long	ss2;		/* 16 high bits zero */
	long	cr3;
	long	eip;
	long	eflags;
	long	eax,ecx,edx,ebx;
	long	esp;
	long	ebp;
	long	esi;
	long	edi;
	long	es;			/* 16 high bits zero */
	long	cs;			/* 16 high bits zero */
	long	ss;			/* 16 high bits zero */
	long	ds;			/* 16 high bits zero */
	long	fs;			/* 16 high bits zero */
	long	gs;			/* 16 high bits zero */
	long	ldt;		/* 16 high bits zero */
	long	trace_bitmap;	/* bits: trace 0, bitmap 16-31 */
	struct i387_struct i387;
};

// 񣨽̣ݽṹΪ
// ==========================
// long state ״̬-1 У0 ()>0 ֹͣ
// long counter ʱ(ݼ)δʱƬ
// long priority ʼʱcounter = priorityԽԽ
// long signal źšλͼÿλһźţźֵ=λƫֵ+1
// struct sigaction sigaction[32] źִԽṹӦźŽҪִеĲͱ־Ϣ
// long blocked ź루Ӧźλͼ
// --------------------------
// int exit_code ִֹͣ˳룬丸̻ȡ
// unsigned long start_code εַ
// unsigned long end_code 볤ȣֽ
// unsigned long end_data 볤 + ݳȣֽ
// unsigned long brk ܳȣֽ
// unsigned long start_stack ջεַ
// long pid ̱ʶ(̺)
// long father ̺š
// long pgrp š
// long session Ựš
// long leader Ự졣
// unsigned short uid ûʶţûid
// unsigned short euid Чûid
// unsigned short suid ûid
// unsigned short gid ʶţid
// unsigned short egid Чid
// unsigned short sgid id
// long alarm ʱֵδ
// long utime û̬ʱ䣨δ
// long stime ϵͳ̬ʱ䣨δ
// long cutime ӽû̬ʱ䡣
// long cstime ӽϵͳ̬ʱ䡣
// long start_time ̿ʼʱ̡
// unsigned short used_math ־ǷʹЭ
// --------------------------
// int tty ʹtty 豸š-1 ʾûʹá
// unsigned short umask ļλ
// struct m_inode * pwd ǰĿ¼i ڵṹ
// struct m_inode * root Ŀ¼i ڵṹ
// struct m_inode * executable ִļi ڵṹ
// unsigned long close_on_exec ִʱرļλͼ־μinclude/fcntl.h
// struct file * filp[NR_OPEN] ʹõļṹ
// --------------------------
// struct desc_struct ldt[3] ľֲ0-գ1-cs2-ݺͶջds&ss
// --------------------------
// struct tss_struct tss ̵״̬Ϣṹ
// ==========================
struct task_struct {
/* these are hardcoded - don't touch */
	long state;			/* -1 unrunnable, 0 runnable, >0 stopped */
	long counter;
	long priority;
	long signal;
	struct sigaction sigaction[32];
	long blocked;		/* bitmap of masked signals */
/* various fields */
	int exit_code;
	unsigned long start_code,end_code,end_data,brk,start_stack;
	long pid,father,pgrp,session,leader;
	unsigned short uid,euid,suid;
	unsigned short gid,egid,sgid;
	long alarm;
	long utime,stime,cutime,cstime,start_time;
	unsigned short used_math;
/* file system info */
	int tty;			/* -1 if no tty, so it must be signed */
	unsigned short umask;
	struct m_inode * pwd;
	struct m_inode * root;
	struct m_inode * executable;
	unsigned long close_on_exec;
	struct file * filp[NR_OPEN];
/* ldt for this task 0 - zero 1 - cs 2 - ds&ss */
	struct desc_struct ldt[3];
/* tss for this task */
	struct tss_struct tss;
};

/*
 *  INIT_TASK is used to set up the first task table, touch at
 * your own risk!. Base=0, limit=0x9ffff (=640kB)
 */
/*
 * INIT_TASK õ1 ޸ģԸ?
 * ַBase = 0γlimit = 0x9ffff=640kB
 */
 // Ӧṹĵ1 Ϣ
#define INIT_TASK \
/* state etc */	{ 0,15,15, \
/* signals */	0,{{},},0, \
/* ec,brk... */	0,0,0,0,0,0, \
/* pid etc.. */	0,-1,0,0,0, \
/* uid etc */	0,0,0,0,0,0, \
/* alarm */	0,0,0,0,0,0, \
/* math */	0, \
/* fs info */	-1,0022,NULL,NULL,NULL,0, \
/* filp */	{NULL,}, \
	{ \
		{0,0}, \
/* ldt */	{0x9f,0xc0fa00}, \
		{0x9f,0xc0f200}, \
	}, \
/*tss*/	{0,PAGE_SIZE+(long)&init_task,0x10,0,0,0,0,(long)&pg_dir,\
	 0,0,0,0,0,0,0,0, \
	 0,0,0x17,0x17,0x17,0x17,0x17,0x17, \
	 _LDT(0),0x80000000, \
		{} \
	}, \
}

extern struct task_struct *task[NR_TASKS];			// 顣
extern struct task_struct *last_task_used_math;		// һʹùЭĽ̡
extern struct task_struct *current;					// ǰ̽ṹָ
extern long volatile jiffies;						// ӿʼĵδ10ms/δ𣩡
extern long startup_time;							// ʱ䡣1970:0:0:0 ʼʱ

#define CURRENT_TIME (startup_time+jiffies/HZ)		// ǰʱ䣨

// Ӷʱʱʱjiffies δʱʱú*fn()( kernel/sched.c)
extern void add_timer(long jiffies, void (*fn)(void));
// жϵĵȴ˯ߡ( kernel/sched.c)
extern void sleep_on(struct task_struct ** p);
// жϵĵȴ˯ߡ( kernel/sched.c)
extern void interruptible_sleep_on(struct task_struct ** p);
// ȷ˯ߵĽ̡( kernel/sched.c)
extern void wake_up(struct task_struct ** p);

/*
 * Entry into gdt where to find first TSS. 0-nul, 1-cs, 2-ds, 3-syscall
 * 4-TSS0, 5-LDT0, 6-TSS1 etc ...
 */
/*
 * Ѱҵ1 TSS ȫֱеڡ0-ûnul1-cs2-ݶds3-ϵͳsyscall
 * 4-״̬TSS05-ֲLTD06-״̬TSS1ȡ
 */
 // ȫֱе1 ״̬(TSS)ѡš
#define FIRST_TSS_ENTRY 4
// ȫֱе1 ֲ(LDT)ѡš
#define FIRST_LDT_ENTRY (FIRST_TSS_ENTRY+1)
// 궨壬ȫֱеn TSS ţѡ
#define _TSS(n) ((((unsigned long) n)<<4)+(FIRST_TSS_ENTRY<<3))
// 궨壬ȫֱеn LDT š
#define _LDT(n) ((((unsigned long) n)<<4)+(FIRST_LDT_ENTRY<<3))
// 궨壬صn Ĵtr
#define ltr(n) __asm__("ltr %%ax"::"a" (_TSS(n)))
// 궨壬صn ľֲĴldtr
#define lldt(n) __asm__("lldt %%ax"::"a" (_LDT(n)))
// ȡǰţеֵ̺pid ͬ
// أn - ǰš( kernel/traps.c)
#define str(n) \
__asm__("str %%ax\n\t" \
	"subl %2,%%eax\n\t" \
	"shrl $4,%%eax" \
	:"=a" (n) \
	:"a" (0),"i" (FIRST_TSS_ENTRY<<3))
/*
 *	switch_to(n) should switch tasks to task nr n, first
 * checking that n isn't the current task, in which case it does nothing.
 * This also clears the TS-flag if the task we switched to has used
 * tha math co-processor latest.
 */
/*
 * switch_to(n)лǰnrnȼn ǵǰ
 * ʲôҲ˳лϴУʹùѧ
 * ЭĻ踴λƼĴcr0 еTS ־
 */
 // 룺%0 - TSS ƫƵַ(*&__tmp.a) %1 - TSS ѡֵ(*&__tmp.b)
 // dx - n ѡecx - ָtask[n]
 // ʱݽṹ__tmp Уa ֵ32 λƫֵb ΪTSS ѡлʱa ֵ
 // ûãԣжϴִǷʹùЭʱͨ״̬εĵַ
 // last_task_used_math еʹùЭ״̬εĵַбȽ϶ġ
#define switch_to(n) {\
struct {long a,b;} __tmp; \
__asm__("cmpl %%ecx,_current\n\t" \
	"je 1f\n\t" \
	"movw %%dx,%1\n\t" \
	"xchgl %%ecx,_current\n\t" \
	"ljmp *%0\n\t" \
	"cmpl %%ecx,_last_task_used_math\n\t" \
	"jne 1f\n\t" \
	"clts\n" \
	"1:" \
	::"m" (*&__tmp.a),"m" (*&__tmp.b), \
	"d" (_TSS(n)),"c" ((long) task[n])); \
}

// ҳַ׼ں˴ûκεط!!
#define PAGE_ALIGN(n) (((n)+0xfff)&0xfffff000)

// λڵַaddr еĸֶַ(ַbase)μб˵
// %0 - ַaddr ƫ2%1 - ַaddr ƫ4%2 - ַaddr ƫ7edx - ַbase
#define _set_base(addr,base)  \
__asm__ ("push %%edx\n\t" \
	"movw %%dx,%0\n\t" \
	"rorl $16,%%edx\n\t" \
	"movb %%dl,%1\n\t" \
	"movb %%dh,%2\n\t" \
	"pop %%edx" \
	::"m" (*((addr)+2)), \
	 "m" (*((addr)+4)), \
	 "m" (*((addr)+7)), \
	 "d" (base) \
	)

#define _set_limit(addr,limit) \
__asm__ ("push %%edx\n\t" \
	"movw %%dx,%0\n\t" \
	"rorl $16,%%edx\n\t" \
	"movb %1,%%dh\n\t" \
	"andb $0xf0,%%dh\n\t" \
	"orb %%dh,%%dl\n\t" \
	"movb %%dl,%1\n\t" \
	"pop %%edx" \
	::"m" (*(addr)), \
	 "m" (*((addr)+6)), \
	 "d" (limit) \
	)

// þֲldt ĻֶַΡ
#define set_base(ldt,base) _set_base( ((char *)&(ldt)) , (base) )
// þֲldt ĶγֶΡ
#define set_limit(ldt,limit) _set_limit( ((char *)&(ldt)) , (limit-1)>>12 )

/**
#define _get_base(addr) ({\
unsigned long __base; \
__asm__("movb %3,%%dh\n\t" \
	"movb %2,%%dl\n\t" \
	"shll $16,%%edx\n\t" \
	"movw %1,%%dx" \
	:"=d" (__base) \
	:"m" (*((addr)+2)), \
	 "m" (*((addr)+4)), \
	 "m" (*((addr)+7)) \
        :"memory"); \
__base;})
**/

// ӵַaddr ȡλַ_set_base()෴
// edx - Żַ(__base)%1 - ַaddr ƫ2%2 - ַaddr ƫ4%3 - addr ƫ7
static inline unsigned long _get_base(char * addr)
{
         unsigned long __base;
         __asm__("movb %3,%%dh\n\t"
                 "movb %2,%%dl\n\t"
                 "shll $16,%%edx\n\t"
                 "movw %1,%%dx"
                 :"=&d" (__base)
                 :"m" (*((addr)+2)),
                  "m" (*((addr)+4)),
                  "m" (*((addr)+7)));
         return __base;
}

// ȡֲldt ָеĻַ
#define get_base(ldt) _get_base( ((char *)&(ldt)) )

// ȡѡsegment Ķγֵ
// %0 - Ŷγֵ(ֽ)%1 - ѡsegment
#define get_limit(segment) ({ \
unsigned long __limit; \
__asm__("lsll %1,%0\n\tincl %0":"=r" (__limit):"r" (segment)); \
__limit;})

#endif
