/*
 *  linux/kernel/rs_io.s
 *
 *  (C) 1991  Linus Torvalds
 */

/*
 *	rs_io.s
 *
 * This module implements the rs232 io interrupts.
 */
/*
 * óģʵrs232 жϴ
 */

.text
.globl _rs1_interrupt,_rs2_interrupt

// size Ƕдлֽڳȡ
size	= 1024				/* must be power of two !and must match the value in tty_io.c!!! */
					   		/* 2 ĴηҪtty_io.cеֵƥ*/

/* these are the offsets into the read/write buffer structures */
/* ЩǶдṹеƫ */
rs_addr = 0 				/* ж˿ںֶƫƣ˿ں0x3f8 0x2f8*/
head = 4					/* ͷֶָƫơ*/
tail = 8					/* βֶָƫơ*/
proc_list = 12				/* ȴûĽֶƫơ*/
buf = 16					/* ֶƫơ*/

startup	= 256		/* chars left in write queue when we restart it */
					/* дﻹʣ256 ַռ(WAKEUP_CHARS)ʱǾͿд */

/*
 * These are the actual interrupt routines. They look where
 * the interrupt is coming from, and take appropriate action.
 */
/*
 * Щʵʵжϳ򡣳ȼжϵԴȻִӦ
 * Ĵ
 */
.align 2
//// ж˿1 жϴڵ㡣
_rs1_interrupt:
	pushl $_table_list+8		/* tty жӦ1 Ķдָĵַջ(tty_io.c)*/
	jmp rs_int
.align 2
//// ж˿2 жϴڵ㡣
_rs2_interrupt:
	pushl $_table_list+16		/* tty жӦ2 Ķдָĵַջ*/
rs_int:
	pushl %edx
	pushl %ecx
	pushl %ebx
	pushl %eax
	push %es
	push %ds					/* as this is an interrupt, we cannot */
	pushl $0x10					/* know that bs is ok. Load it */
	pop %ds						/* һжϳǲ֪ds Ƿȷ*/
	pushl $0x10					/* Լ(dses ָںݶ */
	pop %es
	movl 24(%esp),%edx			/* ַָedx Ĵ*/	
	movl (%edx),%edx			/* ȡָ(ַ)->edx*/
	movl rs_addr(%edx),%edx
	addl $2,%edx		/* interrupt ident. reg */ /* edx ָжϱʶĴ */
rep_int:						/* жϱʶĴ˿0x3fa0x2fa*/
	xorl %eax,%eax
	inb %dx,%al					/* ȡжϱʶֽڣжжԴ(4 ж)*/
	testb $1,%al				/* ж޴ж(λ0=1 жϣ=0 ж)*/
	jne end						/* ޴жϣת˳end*/
	cmpb $6,%al		/* this shouldn't happen, but ... *//* ⲻᷢǡ*/
	ja end						/* al ֵ>6? תendû״̬*/
	movl 24(%esp),%ecx			/* ȡַָ->ecx*/
	pushl %edx					/* ˿ں0x3fa(0x2fa)ջ */
	subl $2,%edx
	call *jmp_table(,%eax,2)		/* NOTE! not *4, bit0 is 0 already *//* 4λ0 0*/
	// ָджʱal λ0=0λ2-1 жͣ൱Ѿж
	// 2ٳ2õתӦж͵ַתȥӦ
	popl %edx					/* жϱʶĴ˿ں0x3fa0x2fa*/
	jmp rep_int					/* תж޴жϲ*/
end:	movb $0x20,%al			/* жϿͽжָEOI*/
	outb %al,$0x20		/* EOI */
	pop %ds
	pop %es
	popl %eax
	popl %ebx
	popl %ecx
	popl %edx
	addl $4,%esp		# jump over _table_list entry # ַָ
	iret

// жʹַת4 жԴ
// modem ״̬仯жϣдַжϣַжϣ·״̬жϡ
jmp_table:
	.long modem_status,write_char,read_char,line_status

.align 2
modem_status:
	addl $6,%edx		/* clear intr by reading modem status reg */
	inb %dx,%al			/* ͨmodem ״̬Ĵиλ(0x3fe) */
	ret

.align 2
line_status:
	addl $5,%edx		/* clear intr by reading line status reg. */
	inb %dx,%al			/* ͨ·״̬Ĵиλ(0x3fd) */
	ret

.align 2
read_char:
	inb %dx,%al					/*ȡջĴ RBR еַ->al*/
	movl %ecx,%edx				/* ǰڻַָ->edx */
	subl $_table_list,%edx		/* ַָ - ǰڶַָ -> edx*/
	shrl $3,%edx				/* ֵ/8ڴ1 1ڴ2 2*/
	movl (%ecx),%ecx		# read-queue	 # ȡнṹַ -> ecx
	movl head(%ecx),%ebx		/* ȡлͷָ -> ebx*/
	movb %al,buf(%ecx,%ebx)		/* ַڻͷָָλá*/
	incl %ebx					/* ͷָǰһֽڡ*/
	andl $size-1,%ebx			/* ûСͷָģָ벻ܳС*/
	cmpl tail(%ecx),%ebx		/* ͷָβָȽϡ*/
	je 1f						/* ȣʾת1 */
	movl %ebx,head(%ecx)		/* ޸Ĺͷָ롣*/
1:	pushl %edx					/* ںѹջ(1- 12 - 2)Ϊ*/
	call _do_tty_interrupt		/* tty жϴC */
	addl $4,%esp				/* ջء*/
	ret

.align 2
write_char:
	movl 4(%ecx),%ecx		# write-queue	# ȡднṹַ->ecx
	movl head(%ecx),%ebx		/* ȡдͷָ->ebx*/
	subl tail(%ecx),%ebx		/* ͷָ - βָ = ַ*/
	andl $size-1,%ebx		# nr chars in queue	# ָȡģ㡣
	je write_buffer_empty		/* ͷָ = βָ룬˵дַת*/
	cmpl $startup,%ebx			/* ַ256 */
	ja 1f						/* ת*/
	movl proc_list(%ecx),%ebx	# wake up sleeping process  # ѵȴĽ̡
	// ȡȴöеĽ̵ָ룬жǷΪա
	testl %ebx,%ebx			# is there any?  # еȴĽ
	je 1f						/* ǿյģǰת1 */
	movl $0,(%ebx)				/* 򽫽Ϊ״̬(ѽ)*/
1:	movl tail(%ecx),%ebx		/* ȡβָ롣*/
	movb buf(%ecx,%ebx),%al		/* ӻβָ봦ȡһַ->al*/
	outb %al,%dx				/* ˿0x3f8(0x2f8)ͳּĴС*/
	incl %ebx					/* βָǰơ*/
	andl $size-1,%ebx			/* βָĩˣۻء*/
	movl %ebx,tail(%ecx)		/* ޸Ĺβָ롣*/
	cmpl head(%ecx),%ebx		/* βָͷָȽ.*/
	je write_buffer_empty		/* ȣʾѿգת*/
	ret
.align 2
write_buffer_empty:
	movl proc_list(%ecx),%ebx	# wake up sleeping process  # ѵȴĽ̡
	// ȡȴöеĽ̵ָ룬жǷΪա
	testl %ebx,%ebx			# is there any?	# еȴĽ
	je 1f									# ޣǰת1 
	movl $0,(%ebx)							# 򽫽Ϊ״̬(ѽ)
1:	incl %edx								# ָ˿0x3f9(0x2f9)
	inb %dx,%al								# ȡжĴ
	jmp 1f
1:	jmp 1f
1:	andb $0xd,%al		/* disable transmit interrupt *//* ηͱּĴжϣλ1 */
	outb %al,%dx
	ret
